<template>
    <a-card :bordered="false">
      <div class="table-page-search-wrapper">
        <a-form layout="inline">
          <a-row :gutter="48">
            <a-col :md="8" :sm="24">
              <a-form-item label="关键字">
                <a-input v-model="queryParam.keyword" placeholder="请输入名称/类型名称"/>
              </a-form-item>
            </a-col>
            <a-col :md="8 || 24" :sm="24">
              <span class="table-page-search-submitButtons">
                <a-button type="primary" @click="$refs.table.refresh(true)">查询</a-button>
                <a-button style="margin-left: 8px" @click="resetSearchForm">重置</a-button>
              </span>
            </a-col>
          </a-row>
        </a-form>
      </div>

      <div class="table-operator" v-if="type == 2">
        <a-button type="primary" icon="plus" @click="handleAdd()">新增</a-button>
        <a-dropdown v-action:edit v-if="selectedRowKeys.length > 0">
          <a-menu slot="overlay">
            <a-popconfirm title="是否要删除所选数据？" @confirm="batchDelete()">
              <a-menu-item key="1"><a-icon type="delete" /><a>删除</a></a-menu-item>
            </a-popconfirm>
          </a-menu>
          <a-button style="margin-left: 8px">
            批量操作 <a-icon type="down" />
          </a-button>
        </a-dropdown>
      </div>

      <s-table
        ref="table"
        size="default"
        rowKey="id"
        :columns="columns"
        :data="loadData"
        :alert="options.alert"
        :customRow="options.customRow"
        :rowSelection="options.rowSelection"
        showPagination="auto"
      >
        <span slot="action" slot-scope="record1">
          <template>
            <a @click="handleView(record1)">查看</a>
            <a-divider type="vertical" />
            <a @click="handleEdit(record1)">修改</a>
            <a-divider type="vertical" />
            <a-popconfirm v-if="record1.status==1" @confirm="handleFeiqi(record1.id)">
              <a>废弃</a>
            </a-popconfirm>
          </template>
        </span>
        <span slot="status" slot-scope="text">
          <badge
            :status="DictCache.COLOR.SPARE_PART_USED_STATUS[text]"
            :text="statusMap[text]" />
        </span>
      </s-table>
      <base-form ref="baseModal" @ok="handleOk"/>
      <detail ref="detailModal"/>
      <template slot="footer">
        <a-button :loading="confirmLoading" type="primary" @click="handleCancel()">取消</a-button>
        <a-button :loading="confirmLoading" type="primary" @click="handleSelect()">选择</a-button>
      </template>
    </a-card>
</template>

<script>
import { STable, Ellipsis } from '@/components'
import BaseForm from './BaseForm'
import Detail from './Detail'
import { getSparePartUsedPage, deleteSparePartUseds, updateSparePartUsed, fetchSparePartUsed, exportSparePartUsed } from '@/api/sqarepartmanage/sparepartused'

export default {
  name: 'SparePartUsedSelectTable',
  components: {
    STable,
    Ellipsis,
    BaseForm,
    Detail
  },
  props: {
    type: {
      type: Number,
      default: 1
    },
    tableParams: {
      type: Object,
      default: () => ({})
    },
    modelParams: {
      type: Object,
      default: () => ({})
    }
  },
  watch: {
    tableParams: {
      // deep: true, // 深度监听
      handler (newVal, oldVal) {
        if (newVal.sbId !== oldVal.sbId) {
          this.handleOk()
        }
      }
    }
  },
  data () {
    return {
      confirmLoading: false,
      mdl: {},
      modalTitle: null,
      visible: false,
      record: null,
      // 查询参数
      queryParam: {
        sbId: this.$route.query.id,
      },
      // 表头
      columns: [
        {
          title: '序号',
          dataIndex: 'index',
          customRender: (text, record, index) => {
            return `${(this.$refs.table.localPagination.current - 1) * this.$refs.table.localPagination.pageSize + index + 1}`
          }
        },
        {
          title: '设备名称',
          dataIndex: 'sbId',
          customRender: (text, record, index) => {
            return record.sbName
          }
        },
        //{
         // title: '部件名称',
          //dataIndex: 'partId',
          //customRender: (text, record, index) => {
          //  return record.partName
         // }
        //},
        {
          title: '备件名称',
          dataIndex: 'spareId',
          customRender: (text, record, index) => {
            return record.spareName
          }
        },
        {
          title: '投用日期',
          dataIndex: 'startDate'
        },
        {
          title: '预计报废日期',
          dataIndex: 'changeDate'
        },
        {
          title: '实际更换日期',
          dataIndex: 'realChangeDate'
        },
        {
          title: '使用状态',
          dataIndex: 'status',
          scopedSlots: { customRender: 'status' }

        },
        {
          title: '操作',
          key: 'action',
          width: '200px',
          align: 'center',
          scopedSlots: { customRender: 'action' }
        }
      ],
      // 下拉框map
      delFlagMap: {},
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        parameter = {
          ...parameter,
          ...this.tableParams,
          ...this.queryParam,
          dataScope: {
            sortBy: 'desc',
            sortName: 'update_time'
          }
        }
        return getSparePartUsedPage(Object.assign(parameter, this.queryParam))
          .then(res => {
            return res.data
          })
      },
      selectedRowKeys: [],
      selectedRows: [],

      options: {
        alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
        rowSelection: {
          selectedRowKeys: this.selectedRowKeys,
          onChange: this.onSelectChange
        }
      },
      optionAlertShow: false,
      isCreated: false
    }
  },
  created () {
    // 下拉框map
    this.statusMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.SPARE_PART_USED_STATUS)
    this.tableOption()
  },
  methods: {
    tableOption () {
      if (!this.optionAlertShow) {
        this.options = {
          alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
          rowSelection: {
            selectedRowKeys: this.selectedRowKeys,
            onChange: this.onSelectChange,
            getCheckboxProps: record => ({
              props: {
                disabled: false,
                name: record.id
              }
            })
          }
        }
        this.optionAlertShow = true
      } else {
        this.options = {
          alert: false,
          rowSelection: null
        }
        this.optionAlertShow = false
      }
    },
    handleView (record) {
      fetchSparePartUsed({ id: record.id }).then(res => {
        const modal = this.$refs.detailModal
        modal.base(res.data)
      })
    },
    batchDelete (id) {
      let ids = []
      if (this.BaseTool.String.isBlank(id)) {
        const length = this.selectedRows.length
        if (length === 0) {
          this.$message.info('请选择要删除的记录')
          return
        }
        ids = this.selectedRows.map(item => item.id)
      } else {
        ids = [id]
      }
      deleteSparePartUseds(ids).then(res => {
        this.$message.info('删除成功')
        this.handleOk()
        this.$refs.table.clearSelected()
      })
    },
    handleEdit (record) {
      fetchSparePartUsed({ id: record.id }).then(res => {
        const modal = this.$refs.baseModal
        modal.base(res.data,{sbId:record.id, modelId: record.modelId})
      })
    },
    handleFeiqi (id) {
      updateSparePartUsed({ id: id, status: 2}).then(res => {
        this.$message.info('废弃成功')
        this.handleOk()
        this.$refs.table.clearSelected()
      })
    },
    handleOk () {
      this.$refs.table.refresh()
    },
    onSelectChange (selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },
    resetSearchForm () {
      this.queryParam = {
      }
      this.$refs.table.refresh(true)
    },
    base (record, queryParam = {}) {
      this.visible = true
      this.modalTitle = '选择信息'
      this.queryParam = queryParam
      this.record = record
      if (this.isCreated) {
        this.$refs.table.clearSelected()
        // this.options.rowSelection.type = this.type
        this.handleOk()
      } else {
        this.tableOption()
        this.isCreated = true
      }
    },
    handleAdd(){
      this.$refs.baseModal.base(null,{sbId:this.tableParams.id, modelId:this.tableParams.modelId, repairId:this.tableParams.repairId})
    },
    handleCancel () {
      this.visible = false
      this.confirmLoading = false
    },
    handleSelect () {
      if (this.selectedRowKeys.length === 0) {
        this.$message.warn('请至少选择一项信息')
      } else {
        this.confirmLoading = true
        this.$emit('selected', this.record, this.selectedRowKeys, this.selectedRows)
        this.confirmLoading = false
        this.visible = false
      }
    },
    mySelect (selectedRowKeys, selectedRows) {
      this.$refs.table.updateSelect(selectedRowKeys, selectedRows)
      this.$refs.table.rowSelection.onChange(selectedRowKeys, selectedRows)
    }
  }
}
</script>
